Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1006)
@@ -3238,48 +1674,6 @@
 
 
-int VspBspTree::SplitPolygons(const Plane3 &plane,
-							  PolygonContainer &polys,
-							  PolygonContainer &frontPolys,
-							  PolygonContainer &backPolys,
-							  PolygonContainer &coincident) const
-{
-	int splits = 0;
-
-	PolygonContainer::const_iterator it, it_end = polys.end();
-
-	for (it = polys.begin(); it != polys.end(); ++ it)	
-	{
-		Polygon3 *poly = *it;
-
-		// classify polygon
-		const int cf = poly->ClassifyPlane(plane, mEpsilon);
-
-		switch (cf)
-		{
-			case Polygon3::COINCIDENT:
-				coincident.push_back(poly);
-				break;
-			case Polygon3::FRONT_SIDE:
-				frontPolys.push_back(poly);
-				break;
-			case Polygon3::BACK_SIDE:
-				backPolys.push_back(poly);
-				break;
-			case Polygon3::SPLIT:
-				backPolys.push_back(poly);
-				frontPolys.push_back(poly);
-				++ splits;
-				break;
-			default:
-                Debug << "SHOULD NEVER COME HERE\n";
-				break;
-		}
-	}
-
-	return splits;
-}
-
-
-int VspBspTree::CastLineSegment(const Vector3 &origin,
+
+int VspOspTree::CastLineSegment(const Vector3 &origin,
 								const Vector3 &termination,
 								ViewCellContainer &viewcells)
@@ -3387,40 +1781,5 @@
 
 
-
-int VspBspTree::TreeDistance(BspNode *n1, BspNode *n2) const
-{
-	std::deque<BspNode *> path1;
-	BspNode *p1 = n1;
-
-	// create path from node 1 to root
-	while (p1)
-	{
-		if (p1 == n2) // second node on path
-			return (int)path1.size();
-
-		path1.push_front(p1);
-		p1 = p1->GetParent();
-	}
-
-	int depth = n2->GetDepth();
-	int d = depth;
-
-	BspNode *p2 = n2;
-
-	// compare with same depth
-	while (1)
-	{
-		if ((d < (int)path1.size()) && (p2 == path1[d]))
-			return (depth - d) + ((int)path1.size() - 1 - d);
-
-		-- d;
-		p2 = p2->GetParent();
-	}
-
-	return 0; // never come here
-}
-
-
-BspNode *VspBspTree::CollapseTree(BspNode *node, int &collapsed)
+BspNode *VspOspTree::CollapseTree(BspNode *node, int &collapsed)
 {
 // TODO
@@ -3464,5 +1823,5 @@
 
 
-int VspBspTree::CollapseTree()
+int VspOspTree::CollapseTree()
 {
 	int collapsed = 0;
@@ -3478,5 +1837,5 @@
 
 
-void VspBspTree::RepairViewCellsLeafLists()
+void VspOspTree::RepairViewCellsLeafLists()
 {
 // TODO
@@ -3521,254 +1880,6 @@
 
 
-typedef pair<BspNode *, BspNodeGeometry *> bspNodePair;
-
-
-int VspBspTree::CastBeam(Beam &beam)
-{
-    stack<bspNodePair> nodeStack;
-	BspNodeGeometry *rgeom = new BspNodeGeometry();
-	ConstructGeometry(mRoot, *rgeom);
-
-	nodeStack.push(bspNodePair(mRoot, rgeom));
-  
-	ViewCell::NewMail();
-
-	while (!nodeStack.empty()) 
-	{
-		BspNode *node = nodeStack.top().first;
-		BspNodeGeometry *geom = nodeStack.top().second;
-		nodeStack.pop();
-		
-		AxisAlignedBox3 box;
-		geom->GetBoundingBox(box);
-
-		const int side = beam.ComputeIntersection(box);
-		
-		switch (side) 
-		{
-		case -1:
-			CollectViewCells(node, true, beam.mViewCells, true);
-			break;
-		case 0:
-			
-			if (node->IsLeaf())
-			{
-				BspLeaf *leaf = dynamic_cast<BspLeaf *>(node);
-			
-				if (!leaf->GetViewCell()->Mailed() && leaf->TreeValid())
-				{
-					leaf->GetViewCell()->Mail();
-					beam.mViewCells.push_back(leaf->GetViewCell());
-				}
-			}
-			else 
-			{
-				BspInterior *interior = dynamic_cast<BspInterior *>(node);
-			
-				BspNode *first = interior->GetFront();
-				BspNode *second = interior->GetBack();
-            
-				BspNodeGeometry *firstGeom = new BspNodeGeometry();
-				BspNodeGeometry *secondGeom = new BspNodeGeometry();
-
-				geom->SplitGeometry(*firstGeom,
-									*secondGeom,
-									interior->GetPlane(),
-									mBox,
-									//0.0000001f);
-									mEpsilon);
-
-				// decide on the order of the nodes
-				if (DotProd(beam.mPlanes[0].mNormal, 
-					interior->GetPlane().mNormal) > 0)
-				{
-					swap(first, second);
-					swap(firstGeom, secondGeom);
-				}
-
-				nodeStack.push(bspNodePair(first, firstGeom));
-				nodeStack.push(bspNodePair(second, secondGeom));
-			}
-			
-			break;
-		default:
-			// default: cull
-			break;
-		}
-		
-		DEL_PTR(geom);
-		
-	}
-
-	return (int)beam.mViewCells.size();
-}
-
-
-void VspBspTree::SetViewCellsManager(ViewCellsManager *vcm)
-{
-	mViewCellsManager = vcm;
-}
-
-
-int VspBspTree::CollectMergeCandidates(const vector<BspLeaf *> leaves,
-									   vector<MergeCandidate> &candidates)
-{
-	BspLeaf::NewMail();
-	
-	vector<BspLeaf *>::const_iterator it, it_end = leaves.end();
-
-	int numCandidates = 0;
-
-	// find merge candidates and push them into queue
-	for (it = leaves.begin(); it != it_end; ++ it)
-	{
-		BspLeaf *leaf = *it;
-		
-		// the same leaves must not be part of two merge candidates
-		leaf->Mail();
-		
-		vector<BspLeaf *> neighbors;
-		
-		// appoximate neighbor search has slightl relaxed constraints
-		if (1)
-			FindNeighbors(leaf, neighbors, true);
-		else
-			FindApproximateNeighbors(leaf, neighbors, true);
-
-		vector<BspLeaf *>::const_iterator nit, nit_end = neighbors.end();
-
-		// TODO: test if at least one ray goes from one leaf to the other
-		for (nit = neighbors.begin(); nit != nit_end; ++ nit)
-		{
-			if ((*nit)->GetViewCell() != leaf->GetViewCell())
-			{
-				MergeCandidate mc(leaf->GetViewCell(), (*nit)->GetViewCell());
-
-				// dont't merge view cells if they are empty and not front and back leaf of the same parent
-				// in the tree?
-				if (mEmptyViewCellsMergeAllowed ||
-					!leaf->GetViewCell()->GetPvs().Empty() || 
-					!(*nit)->GetViewCell()->GetPvs().Empty() ||
-                    leaf->IsSibling(*nit))
-				{
-					candidates.push_back(mc);
-				}
-
-				++ numCandidates;
-				if ((numCandidates % 1000) == 0)
-				{
-					cout << "collected " << numCandidates << " merge candidates" << endl;
-				}
-			}
-		}
-	}
-
-	Debug << "merge queue: " << (int)candidates.size() << endl;
-	Debug << "leaves in queue: " << numCandidates << endl;
-	
-
-	return (int)leaves.size();
-}
-
-
-int VspBspTree::CollectMergeCandidates(const VssRayContainer &rays, 
-									   vector<MergeCandidate> &candidates)
-{
-	ViewCell::NewMail();
-	long startTime = GetTime();
-	
-	map<BspLeaf *, vector<BspLeaf*> > neighborMap;
-	ViewCellContainer::const_iterator iit;
-
-	int numLeaves = 0;
-	
-	BspLeaf::NewMail();
-
-	for (int i = 0; i < (int)rays.size(); ++ i)
-	{  
-		VssRay *ray = rays[i];
-	
-		// traverse leaves stored in the rays and compare and 
-		// merge consecutive leaves (i.e., the neighbors in the tree)
-		if (ray->mViewCells.size() < 2)
-			continue;
-//TODO viewcellhierarchy
-		iit = ray->mViewCells.begin();
-		BspViewCell *bspVc = dynamic_cast<BspViewCell *>(*(iit ++));
-		BspLeaf *leaf = bspVc->mLeaf;
-		
-		// traverse intersections 
-		// consecutive leaves are neighbors => add them to queue
-		for (; iit != ray->mViewCells.end(); ++ iit)
-		{
-			// next pair
-			BspLeaf *prevLeaf = leaf;
-			bspVc = dynamic_cast<BspViewCell *>(*iit);
-            leaf = bspVc->mLeaf;
-
-			// view space not valid or same view cell
-			if (!leaf->TreeValid() || !prevLeaf->TreeValid() ||
-				(leaf->GetViewCell() == prevLeaf->GetViewCell()))
-				continue;
-
-           	vector<BspLeaf *> &neighbors = neighborMap[leaf];
-			
-			bool found = false;
-
-			// both leaves inserted in queue already =>
-			// look if double pair already exists
-			if (leaf->Mailed() && prevLeaf->Mailed())
-			{
-				vector<BspLeaf *>::const_iterator it, it_end = neighbors.end();
-				
-                for (it = neighbors.begin(); !found && (it != it_end); ++ it)
-					if (*it == prevLeaf)
-						found = true; // already in queue
-			}
-		
-			if (!found)
-			{
-				// this pair is not in map yet
-				// => insert into the neighbor map and the queue
-				neighbors.push_back(prevLeaf);
-				neighborMap[prevLeaf].push_back(leaf);
-
-				leaf->Mail();
-				prevLeaf->Mail();
-		
-				MergeCandidate mc(leaf->GetViewCell(), prevLeaf->GetViewCell());
-				
-				candidates.push_back(mc);
-
-				if (((int)candidates.size() % 1000) == 0)
-				{
-					cout << "collected " << (int)candidates.size() << " merge candidates" << endl;
-				}
-			}
-        }
-	}
-
-	Debug << "neighbormap size: " << (int)neighborMap.size() << endl;
-	Debug << "merge queue: " << (int)candidates.size() << endl;
-	Debug << "leaves in queue: " << numLeaves << endl;
-
-
-	//-- collect the leaves which haven't been found by ray casting
-	if (0)
-	{
-		cout << "finding additional merge candidates using geometry" << endl;
-		vector<BspLeaf *> leaves;
-		CollectLeaves(leaves, true);
-		Debug << "found " << (int)leaves.size() << " new leaves" << endl << endl;
-		CollectMergeCandidates(leaves, candidates);
-	}
-
-	return numLeaves;
-}
-
-
-
-
-ViewCell *VspBspTree::GetViewCell(const Vector3 &point, const bool active)
+
+ViewCell *VspOspTree::GetViewCell(const Vector3 &point, const bool active)
 {
 	if (mRoot == NULL)
@@ -3809,5 +1920,5 @@
 
 
-bool VspBspTree::ViewPointValid(const Vector3 &viewPoint) const
+bool VspOspTree::ViewPointValid(const Vector3 &viewPoint) const
 {
 	BspNode *node = mRoot;
@@ -3839,5 +1950,5 @@
 
 
-void VspBspTree::PropagateUpValidity(BspNode *node)
+void VspOspTree::PropagateUpValidity(BspNode *node)
 {
 	const bool isValid = node->TreeValid();
@@ -3868,7 +1979,7 @@
 
 #if ZIPPED_VIEWCELLS
-bool VspBspTree::Export(ogzstream &stream)
+bool VspOspTree::Export(ogzstream &stream)
 #else
-bool VspBspTree::Export(ofstream &stream)
+bool VspOspTree::Export(ofstream &stream)
 #endif
 {
@@ -3878,8 +1989,9 @@
 }
 
+
 #if ZIPPED_VIEWCELLS
-void VspBspTree::ExportNode(BspNode *node, ogzstream &stream)
+void VspOspTree::ExportNode(BspNode *node, ogzstream &stream)
 #else
-void VspBspTree::ExportNode(BspNode *node, ofstream &stream)
+void VspOspTree::ExportNode(BspNode *node, ofstream &stream)
 #endif
 {
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.h	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.h	(revision 1006)
@@ -59,8 +59,8 @@
 				 const Vector3 direction
 				 );
-
+#if 0
   bool
-  ExportVspKdTree(const VspKdTree &tree, const int maxPvs);
-
+  ExportVspOspTree(const VspKdTree &tree, const int maxPvs);
+#endif
   bool ExportBspTree(const BspTree &tree);
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1004)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1006)
@@ -8,5 +8,5 @@
 #include "ViewCellBsp.h"
 #include "KdTree.h"
-#include "VspKdTree.h"
+//#include "VspOspTree.h"
 #include "Exporter.h"
 #include "VspBspTree.h"
@@ -1828,11 +1828,12 @@
 	Vector3 termination = hray.Extrap(tmax);
 
+	// traverse the view space subdivision
 	CastLineSegment(origin, termination, viewcells);
 
-	// copy viewcells memory efficiently
 	//const bool storeViewcells = !addRays;
-
+//return 0;
 	if (storeViewCells)
 	{
+		// copy viewcells memory efficiently
 		ray.mViewCells.reserve(viewcells.size());
 		ray.mViewCells = viewcells;
@@ -2090,5 +2091,4 @@
 	}
 
-
 	return true;
 }
@@ -2173,5 +2173,6 @@
 
 
-void ViewCellsManager::SetScalarPvsSize(ViewCell *vc, const int pvsSize) const
+void ViewCellsManager::SetScalarPvsSize(ViewCell *vc, 
+										const int pvsSize) const
 {
 	vc->mPvsSize = pvsSize;
@@ -3346,366 +3347,4 @@
 }
 
-
-/**********************************************************************/
-/*                   VspKdViewCellsManager implementation             */
-/**********************************************************************/
-
-
-VspKdViewCellsManager::VspKdViewCellsManager(VspKdTree *vspKdTree):
-ViewCellsManager(), mVspKdTree(vspKdTree)
-{
-	Environment::GetSingleton()->GetIntValue("VspKdTree.Construction.samples", mInitialSamples);
-	mVspKdTree->SetViewCellsManager(this);
-}
-
-float VspKdViewCellsManager::GetProbability(ViewCell *viewCell)
-{
-	// compute view cell area / volume as subsititute for probability
-	if (0)
-		return GetArea(viewCell) / GetViewSpaceBox().SurfaceArea();
-	else
-		return GetVolume(viewCell) / GetViewSpaceBox().GetVolume();
-}
-
-
-
-
-void VspKdViewCellsManager::CollectViewCells()
-{
-	mVspKdTree->CollectViewCells(mViewCells);
-}
-
-
-int VspKdViewCellsManager::ConstructSubdivision(const ObjectContainer &objects,
-												const VssRayContainer &rays)
-{
-	// if view cells already constructed
-	if (ViewCellsConstructed())
-		return 0;
-
-	VssRayContainer constructionRays;
-	VssRayContainer savedRays;
-
-	GetRaySets(rays,
-			   mInitialSamples,
-			   constructionRays,
-			   &savedRays);
-
-	Debug << "constructing vsp kd tree using "
-		  << (int)constructionRays.size() << " samples" << endl;
-
-	mVspKdTree->Construct(constructionRays, &mViewSpaceBox);
-	Debug << mVspKdTree->GetStatistics() << endl;
-
-	// export leaf building blocks
-	ExportLeaves(objects, rays);
-
-	// finally merge kd leaf building blocks to view cells
-	const int merged = mVspKdTree->MergeViewCells(rays);
-
-	// collapse siblings belonging to the same view cell
-	mVspKdTree->RefineViewCells(rays);
-
-	// collapse siblings belonging to the same view cell
-	mVspKdTree->CollapseTree();
-
-	// evaluale view cell stats
-	ResetViewCells();
-
-	Debug << "\nView cells after construction:\n" << mCurrentViewCellsStats << endl;
-
-	long startTime = GetTime();
-
-	// recast rest of rays
-	ComputeSampleContributions(savedRays, true, false);
-
-	Debug << "Computed remaining ray contribution in " << TimeDiff(startTime, GetTime()) * 1e-3
-		  << " secs" << endl;
-
-	return merged;
-}
-
-bool VspKdViewCellsManager::ViewCellsConstructed() const
-{
-	return mVspKdTree->GetRoot() != NULL;
-}
-
-
-ViewCell *VspKdViewCellsManager::GenerateViewCell(Mesh *mesh) const
-{
-	return new VspKdViewCell(mesh);
-}
-
-int VspKdViewCellsManager::PostProcess(const ObjectContainer &objects,
-									   const VssRayContainer &rays)
-{
-	if (!ViewCellsConstructed())
-		return 0;
-
-	// recalculate stats
-	EvaluateViewCellsStats();
-
-	return 0;
-}
-
-
-void VspKdViewCellsManager::ExportLeaves(const ObjectContainer &objects,
-										 const VssRayContainer &sampleRays)
-{
-	if (!ViewCellsConstructed())
-		return;
-
-	//-- export leaf building blocks
-	Exporter *exporter = Exporter::GetExporter("vspkdtree.x3d");
-	if (!exporter)
-		return;
-
-	if (mExportGeometry)
-		exporter->ExportGeometry(objects);
-	
-	//exporter->SetWireframe();
-	//exporter->ExportVspKdTree(*mVspKdTree, mVspKdTree->GetStatistics().maxPvsSize);
-	exporter->ExportVspKdTree(*mVspKdTree);
-
-	if (mExportRays)
-	{
-		const float prob = (float)mVisualizationSamples
-			/ ((float)sampleRays.size() + Limits::Small);
-
-		exporter->SetWireframe();
-
-		//-- collect uniformly distributed rays
-		VssRayContainer rays;
-
-		for (int i = 0; i < sampleRays.size(); ++ i)
-		{
-			if (RandomValue(0,1) < prob)
-				rays.push_back(sampleRays[i]);
-		}
-		exporter->ExportRays(rays, RgbColor(1, 0, 0));
-	}
-
-	delete exporter;
-}
-
-
-void VspKdViewCellsManager::Visualize(const ObjectContainer &objects,
-									  const VssRayContainer &sampleRays)
-{
-	if (!ViewCellsConstructed())
-		return;
-
-	//-- export single view cells
-	for (int i = 0; i < 10; ++ i)
-	{
-		char s[64];
-		sprintf(s, "vsp_viewcell%04d.x3d", i);
-		Exporter *exporter = Exporter::GetExporter(s);
-		const int idx =
-			(int)RandomValue(0.0, (Real)((int)mViewCells.size() - 1));
-
-		VspKdViewCell *vc = dynamic_cast<VspKdViewCell *>(mViewCells[idx]);
-
-		//-- export geometry
-		Material m;
-		m.mDiffuseColor = RgbColor(0, 1, 1);
-
-		exporter->SetForcedMaterial(m);
-		exporter->SetWireframe();
-
-		ExportViewCellGeometry(exporter, vc);
-
-		//-- export stored rays
-		
-		if (mExportRays)
-		{
-			ViewCellContainer leaves;
-			mViewCellsTree->CollectLeaves(vc, leaves);
-
-			ViewCellContainer::const_iterator it,
-				it_end = leaves.end();
-
-			for (it = leaves.begin(); it != it_end; ++ it)
-			{
-				VspKdViewCell *vspKdVc = dynamic_cast<VspKdViewCell *>(*it);
-				VspKdLeaf *leaf = vspKdVc->mLeaf;
-				AxisAlignedBox3 box = mVspKdTree->GetBBox(leaf);
-
-				VssRayContainer vssRays;
-
-				VssRayContainer castRays;
-				VssRayContainer initRays;
-
-				leaf->GetRays(vssRays);
-
-				VssRayContainer::const_iterator it, it_end = vssRays.end();
-				const float prop = 200.0f / (float)vssRays.size();
-
-				for (it = vssRays.begin(); it != it_end; ++ it)
-				{
-					if (Random(1) < prop)
-						if ((*it)->mTerminationObject == NULL)
-							castRays.push_back(*it);
-						else
-							initRays.push_back(*it);
-				}
-
-				exporter->ExportRays(castRays, RgbColor(1, 0, 0));
-				exporter->ExportRays(initRays, RgbColor(0, 1, 0));
-			}
-		}
-	
-		//-- output PVS of view cell
-		m.mDiffuseColor = RgbColor(1, 0, 0);
-		exporter->SetForcedMaterial(m);
-
-		Intersectable::NewMail();
-
-		ObjectPvsMap::const_iterator it,
-			it_end = vc->GetPvs().mEntries.end();
-
-		exporter->SetFilled();
-
-		for (it = vc->GetPvs().mEntries.begin(); it != it_end; ++ it)
-		{
-			Intersectable *intersect = (*it).first;
-
-			if (!intersect->Mailed())
-			{
-				Material m = RandomMaterial();
-				exporter->SetForcedMaterial(m);
-
-				exporter->ExportIntersectable(intersect);
-				intersect->Mail();
-			}
-		}
-
-		delete exporter;
-	}
-
-	//-- export final view cells
-	Exporter *exporter = Exporter::GetExporter("vspkdtree_merged.x3d");
-
-
-	ExportViewCellsForViz(exporter);
-
-	if (mExportGeometry)
-	{
-		exporter->SetFilled();
-		exporter->ExportGeometry(objects);
-	}
-
-	if (mExportRays)
-	{
-		const float prob = (float)mVisualizationSamples
-			/ ((float)sampleRays.size() + Limits::Small);
-
-		exporter->SetWireframe();
-
-		VssRayContainer rays;
-
-		for (int i = 0; i < sampleRays.size(); ++ i)
-		{
-		  if (RandomValue(0,1) < prob)
-			rays.push_back(sampleRays[i]);
-		}
-		exporter->ExportRays(rays, RgbColor(1, 0, 0));
-	}
-
-	delete exporter;
-}
-
-int VspKdViewCellsManager::GetType() const
-{
-	return VSP_KD;
-}
-
-
-int VspKdViewCellsManager::CastLineSegment(const Vector3 &origin,
-										   const Vector3 &termination,
-										   ViewCellContainer &viewcells)
-{
-	return mVspKdTree->CastLineSegment(origin, termination, viewcells);
-}
-
-
-void VspKdViewCellsManager::ExportColor(Exporter *exporter,
-										ViewCell *vc) const
-{
-	if (mColorCode == 0) // Random color
-		return;
-
-	float importance = 0;
-
-	switch (mColorCode)
-	{
-	case 1: // pvs
-		{
-			importance = (float)mViewCellsTree->GetPvsSize(vc) /
-				(float)mCurrentViewCellsStats.maxPvs;
-		}
-		break;
-	case 2: // merged leaves
-		{
-        	const int lSize = mViewCellsTree->GetNumInitialViewCells(vc);
-			importance = (float)lSize /
-				(float)mCurrentViewCellsStats.maxLeaves;
-		}
-		break;
-	case 3: // merged tree depth difference
-		{
-			//importance = (float)GetMaxTreeDiff(vc) /
-			//	(float)(mVspBspTree->GetStatistics().maxDepth * 2);
-		}
-		break;
-	default:
-		break;
-	}
-
-	Material m;
-	m.mDiffuseColor.b = 1.0f;
-	m.mDiffuseColor.r = importance;
-	m.mDiffuseColor.g = 1.0f - m.mDiffuseColor.r;
-	//Debug << "importance: " << importance << endl;
-	exporter->SetForcedMaterial(m);
-}
-
-
-void VspKdViewCellsManager::ExportViewCellGeometry(Exporter *exporter,
-												   ViewCell *vc,
-												   const Plane3 *clipPlane) const
-{
-	VspKdViewCell *kdVc = dynamic_cast<VspKdViewCell *>(vc);
-
-	Mesh m;
-
-	ViewCellContainer leaves;
-	mViewCellsTree->CollectLeaves(vc, leaves);
-
-	ViewCellContainer::const_iterator it, it_end = leaves.end();
-
-	for (it = leaves.begin(); it != it_end; ++ it)
-	{
-		VspKdLeaf *l = dynamic_cast<VspKdViewCell *>(*it)->mLeaf;
-		IncludeBoxInMesh(mVspKdTree->GetBBox(l), m);
-	}
-
-	exporter->ExportMesh(&m);
-}
-
-
-void VspKdViewCellsManager::CreateMesh(ViewCell *vc)
-{
-	//TODO
-}
-
-
-void VspKdViewCellsManager::CollectMergeCandidates(const VssRayContainer &rays, 
-												   vector<MergeCandidate> &candidates)
-{
-	// TODO
-}
-
-
 /**************************************************************************/
 /*                   VspBspViewCellsManager implementation                */
@@ -4343,5 +3982,6 @@
 
 			//exporter->SetFilled();
-			bool b = mUseClipPlaneForViz;
+			// HACK: export without clip plane
+			const bool b = mUseClipPlaneForViz;
 			mUseClipPlaneForViz = false;
 			ExportViewCellsForViz(exporter);
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.h	(revision 1004)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.h	(revision 1006)
@@ -158,5 +158,5 @@
 	struct VspBspSplitCandidate
 	{  
-		/// the current node
+		/// the current split plane
 		Plane3 mSplitPlane;
 		/// split axis of this plane (0, 1, 2, or 3 if non-axis-aligned)
@@ -467,7 +467,11 @@
 		@param plane returns the split plane
 		@param leaf the leaf to be split
-		@param polys the polygon list on which the split decition is based
-		@param rays ray container on which selection may be based
+		@param data the traversal data holding the polygons and rays which the split decision is based
+		@param frontData the front node traversal data (which may be updated to avoid repcomputations
+		@param backData the front node traversal data (which may be updated to avoid repcomputations
+		@param splitAxis 0 - 2 if axis aligned split, 3 if polygon-aligned split
+
 		@note the polygons can be reordered in the process
+		
 		@returns true if the cost of the split is under maxCostRatio
 
@@ -567,9 +571,4 @@
 								  float &position);
 
-	/** Selects an axis aligned split plane.
-		@Returns true if split is valied
-	*/
-	bool SelectAxisAlignedPlane(Plane3 &plane, const PolygonContainer &polys) const;
-
 	/** Subdivides the rays into front and back rays according to the split plane.
 		
@@ -649,8 +648,4 @@
 				  int &contributingSamples);
 
-
-
-
-
 	
 	/** Take 3 ray endpoints, where two are minimum and one a maximum
@@ -701,27 +696,32 @@
 	/** Returns estimated memory usage of tree.
 	*/
+	float GetMemUsage() const;
 	//float GetMemUsage(const VspBspTraversalQueue &tstack) const;
-	float GetMemUsage() const;
-
-
-
+
+
+
+	///////////////////////////////////////////////////////////
+protected:
+	
 	/// Pointer to the root of the tree
 	BspNode *mRoot;
-		
+	
+	/// the pointer to the view cells manager
+	ViewCellsManager *mViewCellsManager;
+	
+	/// View cell corresponding to the space outside the valid view space
+	BspViewCell *mOutOfBoundsCell;
+
+	/// the bsp tree statistics
 	BspTreeStatistics mBspStats;
 
-	/// Strategies for choosing next split plane.
-	enum {NO_STRATEGY = 0,
-		  RANDOM_POLYGON = 1, 
-		  AXIS_ALIGNED = 2,
-		  LEAST_RAY_SPLITS = 256,
-		  BALANCED_RAYS = 512,
-		  PVS = 1024
-		};
+	/// sorted split candidates used for sweep-heuristics
+	vector<SortableEntry> *mSplitCandidates;
 
 	/// box around the whole view domain
 	AxisAlignedBox3 mBox;
 
-	bool mUseCostHeuristics;
+	
+	//-- termination critera
 
 	/// minimal number of rays before subdivision termination
@@ -737,45 +737,94 @@
 	/// minimal accumulated ray length
 	float mTermMinAccRayLength;
-
-	//HACK
-	int mTermMinPolygons;
+	/// maximal acceptable cost ratio
+	float mTermMaxCostRatio;
+	/// tolerance value indicating how often the max cost ratio can be failed
+	int mTermMissTolerance;
+
+
+	//-- termination criteria for
+	//-- hybrid stategy where only axis aligned split are used until 
+	//-- a certain point and then also polygon aligned split are taken
+	 
+	/// minimal number of rays where axis aligned split is taken
+	int mTermMinRaysForAxisAligned;
+	/// max ray contribution
+	float mTermMaxRayContriForAxisAligned;
+	/// weight for heuristics evaluation
+	float mAxisAlignedCtDivCi;
+	/// spezifies the split border of the axis aligned split
+	float mAxisAlignedSplitBorder;
+
+
+	//-- global terminatino criteria
 
 	float mTermMinGlobalCostRatio;
 	int mTermGlobalCostMissTolerance;
-
 	int mGlobalCostMisses;
 
-	bool mUseSplitCostQueue;
-	//-- termination criteria for axis aligned split
-
-	/// minimal number of rays for axis aligned split
-	int mTermMinRaysForAxisAligned;
-	// max ray contribution
-	float mTermMaxRayContriForAxisAligned;
-
-	/// strategy to get the best split plane
-	int mSplitPlaneStrategy;
+	/// maximal number of view cells
+	int mMaxViewCells;
+	/// maximal tree memory
+	float mMaxMemory;
+	/// the tree is out of memory
+	bool mOutOfMemory;
+
+
 	/// number of candidates evaluated for the next split plane
 	int mMaxPolyCandidates;
 	/// number of candidates for split planes evaluated using the rays
 	int mMaxRayCandidates;
+	
+
+
+	//-- axis aligned split criteria
+
+	/// if only driving axis should be used for choosing the axis-aligned split
+	bool mOnlyDrivingAxis;
+	/// if heuristics should be used to place the split plane of an axis-aligned split
+	bool mUseCostHeuristics;
+	/// if driving axis should taken if max cost is exceeded for
+	/// all evaluated axis aligned split plane candidates
+	bool mUseDrivingAxisIfMaxCostViolated;
+	/// minimal relative position where the split axis can be placed
+	float mMinBand;
+	/// maximal relative position where the split axis can be placed
+	float mMaxBand;
 	/// balancing factor for PVS criterium
 	float mCtDivCi;
-
-	bool mUseDrivingAxisForMaxCost;
-	//-- axis aligned split criteria
-	float mAxisAlignedCtDivCi;
-	/// spezifies the split border of the axis aligned split
-	float mAxisAlignedSplitBorder;
-
-	/// maximal acceptable cost ratio
-	float mTermMaxCostRatio;
-	/// tolerance value indicating how often the max cost ratio can be failed
-	int mTermMissTolerance;
+	/// if random split axis should be used
+	bool mUseRandomAxis;
+	/// if vsp bsp tree should simulate octree
+	bool mCirculatingAxis;
+
+
+	
+	/// priority queue strategy
+	enum {BREATH_FIRST, DEPTH_FIRST, COST_BASED};
+	/// if we should use breath first priority for the splits
+	int mNodePriorityQueueType;
+	/// if split cost queue should be used to compute next best split
+	bool mUseSplitCostQueue;
+	
+
+	
+	/// Strategies for choosing next split plane.
+	enum {NO_STRATEGY = 0,
+		  RANDOM_POLYGON = 1, 
+		  AXIS_ALIGNED = 2,
+		  LEAST_RAY_SPLITS = 256,
+		  BALANCED_RAYS = 512,
+		  PVS = 1024
+		};
+
+	/// strategy to get the best split plane
+	int mSplitPlaneStrategy;
 
 	//-- factors guiding the split plane heuristics
+
 	float mLeastRaySplitsFactor;
 	float mBalancedRaysFactor;
 	float mPvsFactor;
+
 
 	/// if area or volume should be used for PVS heuristics
@@ -787,40 +836,18 @@
 	/// normalizes different bsp split plane criteria
 	float mCostNormalizer;
-	/// maximal number of view cells
-	int mMaxViewCells;
-	
-	ofstream  mSubdivisionStats;
-
 	// if rays should be stored in leaves
 	bool mStoreRays;
-	
-	/// if only driving axis should be used for split
-	bool mOnlyDrivingAxis;
-
-	ViewCellsManager *mViewCellsManager;
-
-	vector<SortableEntry> *mSplitCandidates;
-
-	
+	/// render cost weight between expected value and variance
 	float mRenderCostWeight;
-	/// View cell corresponding to the space outside the valid view space
-	BspViewCell *mOutOfBoundsCell;
-
-	/// maximal tree memory
-	float mMaxMemory;
-	/// the tree is out of memory
-	bool mOutOfMemory;
-	
+	
+
+	//-- subdivision statistics
+
+	/// subdivision stats output file
+	ofstream mSubdivisionStats;
 	float mTotalCost;
 	int mTotalPvsSize;
 
-	float mMinBand;
-	float mMaxBand;
-
-	//int mSplits;
-	/// subdivision stats output file
-	ofstream mSubdivsionStats;
-	/// if random split axis should be used
-	bool mUseRandomAxis;
+
 	/// use polygon split whenever there are polys left
 	bool mUsePolygonSplitIfAvailable;
@@ -829,14 +856,6 @@
 	/// number of currenly generated view cells
 	int mCreatedViewCells;
-	/// if vsp bsp tree should simulate octree
-	bool mCirculatingAxis;
-
-	/// if we should use breath first priority for the splits
-	int mNodePriorityQueueType;
-
-	bool mEmptyViewCellsMergeAllowed;
-
-	// priority queue strategy
-	enum {BREATH_FIRST, DEPTH_FIRST, COST_BASED};
+
+
 private:
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/BoundingBoxConverter.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/BoundingBoxConverter.h	(revision 939)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/BoundingBoxConverter.h	(revision 1006)
@@ -6,5 +6,5 @@
 namespace GtpVisibilityPreprocessor {
 
-/** helper struct used for identifying objects with similar bounding boxes.
+/** helper struct used to identify objects with similar bounding boxes.
 */
 struct IndexedBoundingBox: public std::pair<int, AxisAlignedBox3>
